// $Id: dynamic_persistent_menu.js,v 1.2.2.5 2010/03/15 15:19:01 yrocq Exp $

/**
 * @file dynamic_persistent_menu.js
 * The Javascript code for Dynamic Persistent Menu
 */
var overMenu=new Array();
var settings_id;
var overStatus = 1;
//TODO Single overStatus for multiple menus supported by the module? Probably needs array.

/**
 * Initialize the module's JS functions
 */
Drupal.behaviors.dynamic_persistent_menu = function() {
  // Set the default overMenu
  //alert(DynamicPersistentMenu['menus']);
  //settings_id = dynamic_persistent_menu_menu_settings_index(overMenu);
  //overMenu = DynamicPersistentMenu.menus[settings_id]['over'];
  var boolStatus=new Array();
  for (var i in DynamicPersistentMenu.menus) {
    boolStatus[i]=0;
  } 
  //overMenu= 'dynamic-persistent-menu-menu'+DynamicPersistentMenu.menus[1]['over'];
 // alert(overMenu);
  // Set mouseover function to show current submenu, hide previous submenu, if any.
  $(".dynamic-persistent-menu-menu-item").mouseover(
    function () {
      overStatus = 1 ;
      //var parentId=$(this).parent().attr("id");
      settings_id = dynamic_persistent_menu_menu_settings_index($(this));
      
      if(boolStatus[settings_id]==0) {
        overMenu[settings_id]= 'dynamic-persistent-menu-menu'+DynamicPersistentMenu.menus[settings_id]['over'];
        //alert(overMenu);
        boolStatus[settings_id]=1;
      }
      // If there was a previous menu which received a mouseover, hide the submenu.
      if (overMenu[settings_id]) {
        subMenu = dynamic_persistent_menu_get_sub_menu(overMenu[settings_id]);
        $('#' + subMenu).hide();
        $('#' + overMenu[settings_id]).removeClass('dynamic-persistent-menu-children-active');
      }
      // Show the submenu of the current menu.
      overMenu[settings_id] = this.id;
      subMenu = dynamic_persistent_menu_get_sub_menu(overMenu[settings_id]);
      $('#' + subMenu).show();
      $('#' + this.id).addClass('dynamic-persistent-menu-children-active');
    }
  ).mouseout(
    function() {
      // Set timeout for the hide function
      dynamic_persistent_menu_set_timeout(settings_id);
    }
  );
      
  // Set mouseover function to keep overStatus as long as mouse is over the current menu.
  $(".dynamic-persistent-menu-sub-menu").mouseover(
    function() {
      if (dynamic_persistent_menu_get_sub_menu(overMenu[settings_id]) == this.id) {
        overStatus = 1;
      }
    }
  ).mouseout(
    function() {
      dynamic_persistent_menu_set_timeout(settings_id);
    }
  );
};

/**
 * Get the id of the submenu of a menu, given its id.
 */
function dynamic_persistent_menu_get_sub_menu(menu_id) {
  return menu_id.replace('dynamic-persistent-menu-menu','dynamic-persistent-menu-sub-menu');
}

/**
 * Get the index of the settings array for a given menu.
 */
function dynamic_persistent_menu_menu_settings_index(menu_id) {
  id = menu_id.parent().attr('id').replace('dynamic-persistent-menu-', '');
  return Number(id);
}

/**
 * Reset all submenus and the corresponding statuses.
 */
function dynamic_persistent_menu_reset() {
  // Hide menu's only if the mouse is not over one of the submenus
  if (!overStatus) {
    // This can be avoided if the menus array index is the actual menu id itself.
   // settings_id = dynamic_persistent_menu_menu_settings_index(overMenu);
    $('#' + dynamic_persistent_menu_get_sub_menu(overMenu[settings_id])).hide();
    $('#' + overMenu[settings_id]).removeClass('dynamic-persistent-menu-children-active');
    //TODO - Use drupal settings array instead of custom settings.
    overMenu[settings_id] = DynamicPersistentMenu.menus[settings_id]['default'];
    $('#' + dynamic_persistent_menu_get_sub_menu(overMenu[settings_id])).show();
  }
}

/**
 * Call timeout function.
 */
function dynamic_persistent_menu_set_timeout(settings_id) {
  //settings_id = dynamic_persistent_menu_menu_settings_index(overMenu);
  //TODO - Use drupal settings array instead of custom settings.
  subMenuTimeout = DynamicPersistentMenu.menus[settings_id]['timeout'];
  overStatus = 0 ;
  setTimeout('dynamic_persistent_menu_reset()', subMenuTimeout);
}
